#!/bin/sh
#
# Copyright (c) 2004 Doctor Web, Ltd.
#
# Author: Sergey Akhapkin <unix-dist@drweb.com>
#
# /etc/init.d/drwebd
#
# Startup script for Dr.Web Antivirus Daemon
#
### BEGIN INIT INFO
# Provides:          drwebd
# Required-Start:   
# X-UnitedLinux-Should-Start: $local_fs $time
# Required-Stop:     
# X-UnitedLinux-Should-Stop: $local_fs $time
# Default-Start:     2 3 5
# Default-Stop:      0 1 6
# Short-Description: drwebd is a Dr.Web(R) Antivirus deamon
# Description: Start Dr.Web daemon to allow Dr.Web filtering
#       software (for mail, samba and squid) use Dr.Web antivirus
#       engine. See for details a documentation is located in
#       /opt/drweb/doc
#
### END INIT INFO
# 

# Check for missing binaries (stale symlinks should not happen)
DRWEBD_BIN=/opt/drweb/drwebd
test -x $DRWEBD_BIN || { echo "$DRWEBD_BIN not installed"; exit 5; }

# Check for existence of needed config file and read it
DRWEBD_INI=/etc/drweb/drweb32.ini
test -r $DRWEBD_INI || { echo "$DRWEBD_INI not existing"; exit 6; }

# Shell functions sourced from /etc/rc.status:
. /etc/rc.status

# Reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0	  - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)

case "$1" in
    start)
	echo -n "Starting drwebd "
	## Start daemon with startproc(8). If this fails
	## the return value is set appropriately by startproc.
	startproc $DRWEBD_BIN -ini=$DRWEBD_INI > /dev/null

	# Remember status and be verbose
	rc_status -v
	;;
    stop)
	echo -n "Shutting down drwebd "
	## Stop daemon with killproc(8) and if this fails
	## killproc sets the return value according to LSB.

	killproc -TERM $DRWEBD_BIN

	# Remember status and be verbose
	rc_status -v
	;;
    try-restart|condrestart)
	## Do a restart only if the service was active before.
	## Note: try-restart is now part of LSB (as of 1.9).
	## RH has a similar command named condrestart.
	if test "$1" = "condrestart"; then
		echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
	fi
	$0 status
	if test $? = 0; then
		$0 restart
	else
		rc_reset	# Not running is not a failure.
	fi
	# Remember status and be quiet
	rc_status
	;;
    restart)
	## Stop the service and regardless of whether it was
	## running or not, start it again.
	$0 stop
	$0 start

	# Remember status and be quiet
	rc_status
	;;
    force-reload)
	## Signal the daemon to reload its config. Most daemons
	## do this on signal 1 (SIGHUP).
	## If it does not support it, restart.

	echo -n "Reloading service drwebd "
	killproc -HUP $DRWEBD_BIN
	#touch /var/drweb/run/drwebd.pid

	rc_status -v
	;;
    reload)
	## Like force-reload, but if daemon does not support
	## signaling, do nothing (!)

	# If it supports signaling:
	echo -n "Reloading service drwebd "
	killproc -HUP $DRWEBD_BIN
	#touch /var/drweb/run/drwebd.pid
	
	rc_status -v
	;;
    status)
	echo -n "Checking for service drwebd "
	## Check status with checkproc(8), if process is running
	## checkproc will return with exit status 0.

	# Return value is slightly different for the status command:
	# 0 - service up and running
	# 1 - service dead, but /var/run/  pid  file exists
	# 2 - service dead, but /var/lock/ lock file exists
	# 3 - service not running (unused)
	# 4 - service status unknown :-(
	# 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)
	
	# NOTE: checkproc returns LSB compliant status values.
	checkproc $DRWEBD_BIN
	# NOTE: rc_status knows that we called this init script with
	# "status" option and adapts its messages accordingly.
	rc_status -v
	;;
    probe)
	## Optional: Probe for the necessity of a reload, print out the
	## argument to this init script which is required for a reload.
	## Note: probe is not (yet) part of LSB (as of 1.9)

	#test $DRWEBD_INI -nt /var/drweb/run/drwebd.pid && echo reload
	;;
    *)
	echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload|probe}"
	exit 1
	;;
esac
rc_exit
